package dmillerw.menu.gui.menu;

import dmillerw.menu.data.click.*;
import dmillerw.menu.data.session.EditSessionData;
import dmillerw.menu.gui.GuiStack;
import dmillerw.menu.gui.menu.button.GuiItemButton;
import dmillerw.menu.helper.GuiRenderHelper;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.resources.I18n;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.client.config.GuiButtonExt;
import org.lwjgl.input.Keyboard;

import javax.annotation.Nonnull;
import java.io.IOException;
import java.util.Collections;

/**
 * @author dmillerw
 */
public class GuiClickAction extends GuiScreen {
    @Nonnull
    public static ItemStack item;

    public static KeyBinding keyBinding;
    private static boolean toggle = false;

    private static boolean clipboard = false;

    private GuiTextField textCommand;
    private GuiTextField textCategory;

    private GuiButtonExt modeCommand;
    private GuiButtonExt modeKeybinding;
    private GuiButtonExt modeUseItem;
    private GuiButtonExt modeCategory;

    private GuiButton commandClipboardButton;
    private GuiButton keybindButton;
    private GuiButton keybindToggleButton;
    private GuiButton selectItemButton;

    private GuiButton buttonCancel;
    private GuiButton buttonConfirm;

    private int mode = 0;

    public GuiClickAction() {
        GuiClickAction.keyBinding = null;
        GuiClickAction.item = ItemStack.field_190927_a;
    }

    @Override
    public void func_73876_c() {
        this.textCommand.func_146178_a();
        this.textCategory.func_146178_a();
    }

    @Override
    public void func_73866_w_() {
        if (GuiClickAction.keyBinding != null) {
            mode = ClickAction.KEYBIND.ordinal();
        } else if (!GuiClickAction.item.func_190926_b()) {
            mode = ClickAction.ITEM_USE.ordinal();
        } else {
            mode = EditSessionData.clickAction != null ? EditSessionData.clickAction.getClickAction().ordinal() : 0;
        }

        Keyboard.enableRepeatEvents(true);

        this.field_146292_n.clear();

        this.field_146292_n.add(this.buttonConfirm = new GuiButton(0, this.field_146294_l / 2 - 4 - 150, this.field_146295_m - 60, 150, 20, I18n.func_135052_a("gui.done")));
        this.field_146292_n.add(this.buttonCancel = new GuiButton(1, this.field_146294_l / 2 + 4, this.field_146295_m - 60, 150, 20, I18n.func_135052_a("gui.cancel")));

        String commandString;
        if (EditSessionData.clickAction != null && EditSessionData.clickAction instanceof ClickActionCommand) {
            commandString = ((ClickActionCommand) EditSessionData.clickAction).clipboard ? "Clipboard" : "Send";
        } else {
            commandString = clipboard ? "Clipboard" : "Send";
        }
        this.field_146292_n.add(this.commandClipboardButton = new GuiButton(9, this.field_146294_l / 2 - 75, 80, 150, 20, commandString));

        String keyString;
        if (GuiClickAction.keyBinding != null) {
            keyString = I18n.func_135052_a(keyBinding.func_151464_g());
        } else {
            if (EditSessionData.clickAction != null && EditSessionData.clickAction instanceof ClickActionKey) {
                keyString = I18n.func_135052_a(((ClickActionKey) EditSessionData.clickAction).key);
            } else {
                keyString = "Select a key";
            }
        }
        this.field_146292_n.add(this.keybindButton = new GuiButton(2, this.field_146294_l / 2 - 75, 50, 150, 20, keyString));

        String keyToggleString;
        if (EditSessionData.clickAction != null && EditSessionData.clickAction instanceof ClickActionKey) {
            keyToggleString = ((ClickActionKey) EditSessionData.clickAction).toggle ? "Toggle" : "Press";
        } else {
            keyToggleString = toggle ? "Toggle" : "Press";
        }
        this.field_146292_n.add(this.keybindToggleButton = new GuiButton(3, this.field_146294_l / 2 - 75, 80, 150, 20, keyToggleString));

        String itemString;
        if (!GuiClickAction.item.func_190926_b()) {
            itemString = "Item: " + item.func_82833_r();
        } else {
            if (EditSessionData.clickAction != null && EditSessionData.clickAction.getClickAction() == ClickAction.ITEM_USE) {
                itemString = "Item: " + ((ClickActionUseItem) EditSessionData.clickAction).stack.func_82833_r();
            } else {
                itemString = "Select a Slot";
            }
        }
        this.field_146292_n.add(this.selectItemButton = new GuiButton(4, this.field_146294_l / 2 - 75, 50, 150, 20, itemString));

        this.field_146292_n.add(this.modeCommand = new GuiItemButton(5, this.field_146294_l / 2 - 55, this.field_146295_m - 90, 20, 20, new ItemStack(Items.field_151121_aF)));
        this.field_146292_n.add(this.modeKeybinding = new GuiItemButton(6, this.field_146294_l / 2 - 25, this.field_146295_m - 90, 20, 20, new ItemStack(Blocks.field_150471_bO)));
        this.field_146292_n.add(this.modeUseItem = new GuiItemButton(7, this.field_146294_l / 2 + 5, this.field_146295_m - 90, 20, 20, new ItemStack(Items.field_151048_u)));
        this.field_146292_n.add(this.modeCategory = new GuiItemButton(8, this.field_146294_l / 2 + 35, this.field_146295_m - 90, 20, 20, new ItemStack(Blocks.field_150486_ae)));

        this.textCommand = new GuiTextField(0, this.field_146289_q, this.field_146294_l / 2 - 150, 50, 300, 20);
        this.textCommand.func_146203_f(32767);
        this.textCommand.func_146195_b(true);
        this.textCommand.func_146180_a((EditSessionData.clickAction != null && EditSessionData.clickAction instanceof ClickActionCommand) ? ((ClickActionCommand) EditSessionData.clickAction).command : "");

        this.textCategory = new GuiTextField(0, this.field_146289_q, this.field_146294_l / 2 - 150, 50, 300, 20);
        this.textCategory.func_146203_f(32767);
        this.textCategory.func_146195_b(true);
        this.textCategory.func_146180_a((EditSessionData.clickAction != null && EditSessionData.clickAction instanceof ClickActionCategory) ? ((ClickActionCategory) EditSessionData.clickAction).category : "");

        this.modeCommand.field_146124_l = mode != 0;
        this.modeKeybinding.field_146124_l = mode != 1;
        this.modeUseItem.field_146124_l = mode != 2;
        this.modeCategory.field_146124_l = mode != 3;

        textCommand.func_146189_e(mode == 0);
        commandClipboardButton.field_146125_m = mode == 0;
        keybindButton.field_146125_m = mode == 1;
        keybindToggleButton.field_146125_m = mode == 1;
        selectItemButton.field_146125_m = mode == 2;
        textCategory.func_146189_e(mode == 3);
    }

    @Override
    public void func_146281_b() {
        Keyboard.enableRepeatEvents(false);
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146284_a(GuiButton button) {
        if (button.field_146124_l) {
            if (button.field_146127_k == 8) {
                // Category
                mode = 3;

                modeCategory.field_146124_l = false;
                modeUseItem.field_146124_l = true;
                modeKeybinding.field_146124_l = true;
                modeCommand.field_146124_l = true;

                textCategory.func_146189_e(true);
                selectItemButton.field_146125_m = false;
                textCommand.func_146189_e(false);
                commandClipboardButton.field_146125_m = false;
                keybindButton.field_146125_m = false;
                keybindToggleButton.field_146125_m = false;
            } else if (button.field_146127_k == 7) {
                // Select item
                mode = 2;

                modeCategory.field_146124_l = true;
                modeUseItem.field_146124_l = false;
                modeKeybinding.field_146124_l = true;
                modeCommand.field_146124_l = true;

                textCategory.func_146189_e(false);
                selectItemButton.field_146125_m = true;
                textCommand.func_146189_e(false);
                commandClipboardButton.field_146125_m = false;
                keybindButton.field_146125_m = false;
                keybindToggleButton.field_146125_m = false;
            } else if (button.field_146127_k == 6) {
                // Keybinding
                mode = 1;

                modeCategory.field_146124_l = true;
                modeUseItem.field_146124_l = true;
                modeKeybinding.field_146124_l = false;
                modeCommand.field_146124_l = true;

                textCategory.func_146189_e(false);
                selectItemButton.field_146125_m = false;
                textCommand.func_146189_e(false);
                commandClipboardButton.field_146125_m = false;
                keybindButton.field_146125_m = true;
                keybindToggleButton.field_146125_m = true;
            } else if (button.field_146127_k == 5) {
                // Command
                mode = 0;

                modeCategory.field_146124_l = true;
                modeUseItem.field_146124_l = true;
                modeKeybinding.field_146124_l = true;
                modeCommand.field_146124_l = false;

                textCategory.func_146189_e(false);
                selectItemButton.field_146125_m = false;
                textCommand.func_146189_e(true);
                commandClipboardButton.field_146125_m = true;
                keybindButton.field_146125_m = false;
                keybindToggleButton.field_146125_m = false;
            } else if (button.field_146127_k == 9) {
                clipboard = !clipboard;
                commandClipboardButton.field_146126_j = clipboard ? "Clipboard" : "Send";
            } else if (button.field_146127_k == 4) {
                GuiStack.push(new GuiPickItem());
            } else if (button.field_146127_k == 3) {
                toggle = !toggle;
                keybindToggleButton.field_146126_j = toggle ? "Toggle" : "Press";
            } else if (button.field_146127_k == 2) {
                GuiStack.push(new GuiPickKey());
            } else if (button.field_146127_k == 1) {
                GuiStack.pop();
            } else if (button.field_146127_k == 0) {
                if (mode == 0) {
                    EditSessionData.clickAction = !(textCommand.func_146179_b().trim().isEmpty()) ? new ClickActionCommand(textCommand.func_146179_b().trim(), clipboard) : null;
                } else if (mode == 1 && GuiClickAction.keyBinding != null) {
                    EditSessionData.clickAction = new ClickActionKey(keyBinding.func_151464_g(), toggle);
                } else if (mode == 2 && !GuiClickAction.item.func_190926_b()) {
                    EditSessionData.clickAction = new ClickActionUseItem(item);
                } else if (mode == 3) {
                    EditSessionData.clickAction = !(textCategory.func_146179_b().trim().isEmpty()) ? new ClickActionCategory(textCategory.func_146179_b().trim()) : null;
                }
                GuiStack.pop();
            }
        }
    }

    @Override
    protected void func_73869_a(char key, int keycode) {
        this.textCommand.func_146201_a(key, keycode);
        this.textCategory.func_146201_a(key, keycode);

        if (keycode != 28 && keycode != 156) {
            if (keycode == 1) {
                this.func_146284_a(this.buttonCancel);
            }
        }
    }

    @Override
    protected void func_73864_a(int mx, int my, int button) throws IOException {
        super.func_73864_a(mx, my, button);

        this.textCommand.func_146192_a(mx, my, button);
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partial) {
        this.func_146276_q_();
        this.textCommand.func_146194_f();
        this.textCategory.func_146194_f();
        super.func_73863_a(mouseX, mouseY, partial);
        String header = "";
        switch (mode) {
            case 0: header = "Enter a command"; break;
            case 1: header = "Select a key"; break;
            case 2: header = "Pick an item"; break;
            case 3: header = "Enter a category"; break;
        }
        GuiRenderHelper.renderHeaderAndFooter(this, 25, 20, 5, header);
        if (mouseX > modeCommand.field_146128_h && mouseX < modeCommand.field_146128_h + modeCommand.field_146120_f && mouseY > modeCommand.field_146129_i && mouseY < modeCommand.field_146129_i + modeCommand.field_146120_f) {
            this.func_146283_a(Collections.singletonList("Click Action: Command"), mouseX, mouseY);
        } else if (mouseX > modeKeybinding.field_146128_h && mouseX < modeKeybinding.field_146128_h + modeKeybinding.field_146120_f && mouseY > modeKeybinding.field_146129_i && mouseY < modeKeybinding.field_146129_i + modeKeybinding.field_146120_f) {
            this.func_146283_a(Collections.singletonList("Click Action: KeyBinding"), mouseX, mouseY);
        } else if (mouseX > modeUseItem.field_146128_h && mouseX < modeUseItem.field_146128_h + modeUseItem.field_146120_f && mouseY > modeUseItem.field_146129_i && mouseY < modeUseItem.field_146129_i + modeUseItem.field_146120_f) {
            this.func_146283_a(Collections.singletonList("Click Action: Use Item"), mouseX, mouseY);
        } else if (mouseX > modeCategory.field_146128_h && mouseX < modeCategory.field_146128_h + modeCategory.field_146120_f && mouseY > modeCategory.field_146129_i && mouseY < modeCategory.field_146129_i + modeCategory.field_146120_f) {
            this.func_146283_a(Collections.singletonList("Click Action: Category"), mouseX, mouseY);
        }
    }
}
