package dmillerw.menu.gui.menu;

import dmillerw.menu.MineMenu;
import dmillerw.menu.data.click.ClickActionCommand;
import dmillerw.menu.data.click.ClickActionKey;
import dmillerw.menu.data.json.MenuLoader;
import dmillerw.menu.data.menu.MenuItem;
import dmillerw.menu.data.menu.RadialMenu;
import dmillerw.menu.data.session.EditSessionData;
import dmillerw.menu.gui.GuiStack;
import dmillerw.menu.gui.menu.button.GuiItemButton;
import dmillerw.menu.helper.GuiRenderHelper;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.resources.I18n;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import org.lwjgl.input.Keyboard;

import java.io.IOException;

/**
 * @author dmillerw
 */
public class GuiMenuItem extends GuiScreen {
    private final int slot;

    private GuiTextField textTitle;

    private GuiButton buttonCancel;
    private GuiButton buttonConfirm;
    private GuiButton buttonDelete;
    private GuiItemButton buttonPickIcon;
    private GuiButton buttonClickAction;

    public GuiMenuItem(int slot, MenuItem menuItem) {
        this.slot = slot;

        EditSessionData.fromMenuItem(menuItem);
    }

    @Override
    public void func_73876_c() {
        this.textTitle.func_146178_a();
    }

    @Override
    public void func_73866_w_() {
        Keyboard.enableRepeatEvents(true);

        this.field_146292_n.clear();

        this.field_146292_n.add(this.buttonConfirm = new GuiButton(0, this.field_146294_l / 2 - 4 - 150, this.field_146295_m - 60, 100, 20, I18n.func_135052_a("gui.done")));
        this.field_146292_n.add(this.buttonCancel = new GuiButton(1, this.field_146294_l / 2 + 4 + 50, this.field_146295_m - 60, 100, 20, I18n.func_135052_a("gui.cancel")));
        this.field_146292_n.add(this.buttonDelete = new GuiButton(2, this.field_146294_l / 2 - 50, this.field_146295_m - 60, 100, 20, "Delete"));

        this.field_146292_n.add(this.buttonPickIcon = new GuiItemButton(3, this.field_146294_l / 2 - 4 - 40, this.field_146295_m / 2, 20, 20, new ItemStack(Blocks.field_150348_b)));
        String string = "Action";
        if (EditSessionData.clickAction != null) {
            if (EditSessionData.clickAction instanceof ClickActionCommand) {
                string = "Command";
            } else if (EditSessionData.clickAction instanceof ClickActionKey) {
                string = "Keybind";
            }
        }
        this.field_146292_n.add(this.buttonClickAction = new GuiButton(4, this.field_146294_l / 2 - 20, this.field_146295_m / 2, 100, 20, string));

        this.textTitle = new GuiTextField(9, this.field_146289_q, this.field_146294_l / 2 - 150, 50, 300, 20);
        this.textTitle.func_146203_f(32767);
        this.textTitle.func_146195_b(false);
        this.textTitle.func_146180_a(EditSessionData.title != null && !EditSessionData.title.isEmpty() ? EditSessionData.title : "");

        this.buttonPickIcon.icon = EditSessionData.icon;

        this.buttonConfirm.field_146124_l = !this.textTitle.func_146179_b().trim().isEmpty();
    }

    @Override
    public void func_146281_b() {
        Keyboard.enableRepeatEvents(false);
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146284_a(GuiButton button) {
        if (button.field_146124_l) {
            if (button.field_146127_k == 4) {
                GuiStack.push(new GuiClickAction());
            } else if (button.field_146127_k == 3) {
                GuiStack.push(new GuiPickIcon());
            } else if (button.field_146127_k == 2) {
                if (RadialMenu.getActiveArray()[slot] != null) {
                    RadialMenu.getActiveArray()[slot].onRemoved();
                    RadialMenu.getActiveArray()[slot] = null;
                    MenuLoader.save(MineMenu.menuFile);
                    Minecraft.func_71410_x().func_147108_a(null);
                }
            } else if (button.field_146127_k == 1) {
                Minecraft.func_71410_x().func_147108_a(null);
            } else if (button.field_146127_k == 0) {
                if (!EditSessionData.title.trim().isEmpty() && EditSessionData.clickAction != null) {
                    if (RadialMenu.getActiveArray()[slot] != null) {
                        RadialMenu.getActiveArray()[slot].onRemoved();
                    }
                    RadialMenu.getActiveArray()[slot] = EditSessionData.toMenuItem();
                }
                MenuLoader.save(MineMenu.menuFile);
                Minecraft.func_71410_x().func_147108_a(null);
            }
        }
    }

    @Override
    protected void func_73869_a(char key, int keycode) {
        if (this.textTitle.func_146201_a(key, keycode)) {
            EditSessionData.title = textTitle.func_146179_b().trim();
        }

        this.buttonConfirm.field_146124_l = this.textTitle.func_146179_b().trim().length() > 0;

        if (keycode != 28 && keycode != 156) {
            if (keycode == 1) {
                this.func_146284_a(this.buttonCancel);
            }
        }
    }

    @Override
    protected void func_73864_a(int mx, int my, int button) throws IOException {
        super.func_73864_a(mx, my, button);

        this.textTitle.func_146192_a(mx, my, button);
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partial) {
        this.func_146276_q_();
        this.textTitle.func_146194_f();
        this.func_73732_a(this.field_146289_q, "Enter a title, then configure using the options below", this.field_146294_l / 2, 80, 16777215);
        super.func_73863_a(mouseX, mouseY, partial);
        GuiRenderHelper.renderHeaderAndFooter(this, 25, 20, 5, "Modifying Menu Item #" + slot);
    }
}
