package dmillerw.menu.gui.menu.list;

import dmillerw.menu.gui.GuiStack;
import dmillerw.menu.gui.menu.GuiClickAction;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiListExtended;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.resources.I18n;
import net.minecraft.client.settings.GameSettings;
import net.minecraft.client.settings.KeyBinding;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import net.minecraft.client.gui.GuiListExtended.IGuiListEntry;

/**
 * @author dmillerw
 */
@SideOnly(Side.CLIENT)
public class GuiControlList extends GuiListExtended {

    private final Minecraft mc;

    private final List<IGuiListEntry> list;

    private int maxWidth = 0;

    public GuiControlList(GuiScreen parent, Minecraft mc) {
        super(mc, parent.field_146294_l, parent.field_146295_m, 25, parent.field_146295_m - 20, 20);
        this.mc = mc;
        this.list = new ArrayList<IGuiListEntry>();

        KeyBinding[] keyBindings = Minecraft.func_71410_x().field_71474_y.field_74324_K;
        Arrays.sort(keyBindings);

        String lastCategory = "";

        for (KeyBinding keybinding : keyBindings) {
            String category = keybinding.func_151466_e();

            if (keybinding.func_151469_h() >= 0 && !keybinding.func_151464_g().equalsIgnoreCase("key.open_menu")) {
                if (!category.equals(lastCategory)) {
                    lastCategory = category;
                    list.add(new CategoryEntry(category));
                }

                int l = mc.field_71466_p.func_78256_a(I18n.func_135052_a(keybinding.func_151464_g()));

                if (l > this.maxWidth) {
                    this.maxWidth = l;
                }

                list.add(new KeyEntry(keybinding));
            }
        }
    }

    @Override
    protected int func_148127_b() {
        return list.size();
    }

    @Override
    @Nonnull
    public GuiListExtended.IGuiListEntry func_148180_b(int index) {
        return list.get(index);
    }

    @Override
    protected int func_148137_d() {
        return super.func_148137_d() + 15;
    }

    @Override
    protected void drawContainerBackground(Tessellator tessellator) {
    }

    @SideOnly(Side.CLIENT)
    public class CategoryEntry implements GuiListExtended.IGuiListEntry {

        private final String category;

        private final int width;

        CategoryEntry(String category) {
            this.category = I18n.func_135052_a(category);
            this.width = GuiControlList.this.mc.field_71466_p.func_78256_a(this.category);
        }

        @Override
        public void func_178011_a(int p_178011_1_, int p_178011_2_, int p_178011_3_) {
        }

        @Override
        public void func_180790_a(int x, int y, int z, int listWidth, int slotHeight, int mouseX, int mouseY, boolean isSelected) {
            if (GuiControlList.this.mc.field_71462_r != null) {
                GuiControlList.this.mc.field_71466_p.func_78276_b(this.category, GuiControlList.this.mc.field_71462_r.field_146294_l / 2 - this.width / 2, z + slotHeight - GuiControlList.this.mc.field_71466_p.field_78288_b - 1, 16777215);
            }
        }

        @Override
        public boolean func_148278_a(int slotIndex, int p_148278_2_, int p_148278_3_, int p_148278_4_, int p_148278_5_, int p_148278_6_) {
            return false;
        }

        @Override
        public void func_148277_b(int slotIndex, int x, int y, int mouseEvent, int relativeX, int relativeY) {

        }
    }

    @SideOnly(Side.CLIENT)
    public class KeyEntry implements GuiListExtended.IGuiListEntry {

        private final KeyBinding keyBinding;

        private final String description;

        private final GuiButton buttonSelect;

        private KeyEntry(KeyBinding keyBinding) {
            this.keyBinding = keyBinding;
            this.description = I18n.func_135052_a(keyBinding.func_151464_g());
            this.buttonSelect = new GuiButton(0, 0, 0, 75, 18, description);
        }

        @Override
        public void func_178011_a(int p_178011_1_, int p_178011_2_, int p_178011_3_) {
        }

        @Override
        public void func_180790_a(int x, int y, int z, int listWidth, int slotHeight, int mouseX, int mouseY, boolean isSelected) {
            GuiControlList.this.mc.field_71466_p.func_78276_b(this.description, y + 90 - GuiControlList.this.maxWidth, z + slotHeight / 2 - GuiControlList.this.mc.field_71466_p.field_78288_b / 2, 16777215);
            this.buttonSelect.field_146128_h = y + 105;
            this.buttonSelect.field_146129_i = z;
            this.buttonSelect.field_146126_j = GameSettings.func_74298_c(this.keyBinding.func_151463_i());
            this.buttonSelect.func_146112_a(GuiControlList.this.mc, mouseX, mouseY);
        }

        @Override
        public boolean func_148278_a(int slotIndex, int p_148278_2_, int p_148278_3_, int p_148278_4_, int p_148278_5_, int p_148278_6_) {
            if (buttonSelect.func_146116_c(GuiControlList.this.mc, p_148278_2_, p_148278_3_)) {
                GuiClickAction.keyBinding = keyBinding;
                GuiStack.pop();
                return true;
            }
            return false;
        }

        @Override
        public void func_148277_b(int slotIndex, int x, int y, int mouseEvent, int relativeX, int relativeY) {

        }
    }
}
